% compute a 3D image of a beam using the fast nearfield method
%

if true
%clear all;

c=1500; % speed of sound
f0=1.50e6; % frequency
lambda=c/f0;% wavelength
k=2*pi/lambda; % wave number
u0=1; % surface velocity
rho=1000; % density

a=3*lambda-200e-6; % array element width in azimuth
b=3*lambda-200e-6; % array element width in elevation


%f = 1540000;
%c = 1500;
%k = 2*pi*f/c;
%lambda = c/f;

s = a*2;%5*lambda;
l = b*2;%7.5*lambda;

%siz=[93 1 93]; %[500 1 200];
%siz=[64 64 128];
siz=[256 256 256]
%delta = lambda/2; %0.001;
dist=[lambda/2 lambda/2 lambda]; %s/2/(siz(1)-2)/2*3    s/2/(siz(2))   s*s/4/lambda/(siz(3)-2)]*2.0;


tic
%out = MLFourElement(dist, siz, l, s, k);
trans = [ dist(1) 0 0 -0.5*siz(1)*dist(1); 0 dist(2) 0 -0.5*siz(2)*dist(2); 0 0 dist(3) 0; 0 0 0 1 ]
trans = transpose(trans);
out = MLRectangularPistonGrid(trans, siz, l, s, k, 'cuda');
toc
% out

%tmp=rho*c*c*u0/2/pi; %/7.6624;
tmp=rho*c*u0;
out = tmp * out;
norm = abs(out);

%norm2 = reshape(norm, [(siz(1)) (siz(3))]);
% norm2

%figure; surf(norm2);
%axis tight;

end

%figure;
% generate 0.2 degree isosurface
[x0, y0, z0] = meshgrid(1:siz(1), 1:siz(2), 1:siz(3));
figure;
%iso = 1000000;
iso =  300000;
p=patch(isosurface(x0,y0,z0,norm,iso));
p2=patch(isocaps(x0,y0,z0,norm,iso),'FaceColor','interp','EdgeColor','none');
isonormals(x0,y0,z0,norm,p);
colormap(jet(256))
colorbar

set(p,'FaceColor','red','EdgeColor','none');
%daspect([1 1 1]);
%view(-107,-18);
%view(-61,8);
camlight headlight;
camlight;
lighting gouraud;
%axis([-25 25 -25 25 -25 25]);
box on