clear all;

z = 2;
k = 10;

N =700;

for kyi=0:N
    for kxi=0:N
        kx = kxi-N/2;
        ky = kyi-N/2;
        r = sqrt(kx^2 + ky^2 + z^2);
        hu(kxi+1,kyi+1) = exp( -j*k*r )/2/pi/r;
    end
end


for kyi=0:N
    for kxi=0:N
        kx = kxi-N/2;
        ky = kyi-N/2;
        if(kx^2 + ky^2 <= k^2)
            Hu(kxi+1,kyi+1) = exp( -j * z * sqrt( k^2 - kx^2 - ky^2 ))/(j * sqrt(k^2 - kx^2 - ky^2));
        else
            Hu(kxi+1,kyi+1) = exp( -z * sqrt( kx^2 + ky^2 - k^2 ))/sqrt( kx^2 + ky^2 - k^2 );
        end
    end
end

D=100;
for ky=0:N
    for kx=0:N
        kx = kxi-N/2;
        ky = kyi-N/2;
        kc(kxi+1, kyi+1) = k * sqrt( ( D^2/2 ) / ( D^2/2 + z^2 ));
    end
end

figure(1)
imagesc(abs(hu)); colorbar;

figure(2)
imagesc( abs(Hu) ); colorbar;
figure(3)
imagesc( angle(Hu) ); colorbar; colormap('HSV');

figure(4)
imagesc( kc ); colorbar;


