%
% test angular spectrum approach
%
%


% compute initial grid (2D plane)
f0=1.5e6;
c=1500;
lambda=f0/c;
k=2*pi/(c/f0);

N=128;
D=100/1000;
a=1;
delta=D/(N-1);





siz=[N N N];

delta = lambda*0.01; %0.001;
dist=[delta delta delta]; %s/2/(siz(1)-2)/2*3    s/2/(siz(2))   s*s/4/lambda/(siz(3)-2)]*2.0;

z0 = delta;
l = k/2;
s = k/4;

trans = [ dist(1) 0 0 -0.5*siz(1)*dist(1); ...
          0 dist(2) 0 -0.5*siz(2)*dist(2); ...
          0 0 dist(3) z0; ...
          0 0 0 1 ];
%trans = transpose(trans);

volume = MLRectangularPistonGrid(trans, siz, l, s, k, 'cuda');

plane = volume(:,:,1);   % remove 3rd dimension

plane = plane.*1000;

figure(2);
imagesc(abs(plane));

figure(3);
isosurface(abs(volume), 0.5);